org.eclipse.january.dataset

## Class CompoundShortDataset

- java.lang.Object
- - org.eclipse.january.dataset.LazyDatasetBase
  - - org.eclipse.january.dataset.AbstractDataset
    - - org.eclipse.january.dataset.AbstractCompoundDataset
      - - org.eclipse.january.dataset.CompoundShortDataset

- All Implemented Interfaces:
    Serializable, CompoundDataset, Dataset, IDataset, ILazyDataset, IMetadataProvider, INameable
  Direct Known Subclasses:
    RGBDataset

      public class CompoundShortDataset
      extends AbstractCompoundDataset

  Extend compound dataset for short values // PRIM_TYPE
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected short[]` | `data`

    - ### Fields inherited from class org.eclipse.january.dataset.AbstractCompoundDataset

      `isize`

    - ### Fields inherited from class org.eclipse.january.dataset.AbstractDataset

      `base, BLOCK_CLOSE, BLOCK_OPEN, ELLIPSIS, odata, offset, size, stride, stringFormat`

    - ### Fields inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `metadata, name, shape`

    - ### Fields inherited from interface org.eclipse.january.dataset.Dataset

      `ARRAYFLOAT32, ARRAYFLOAT64, ARRAYINT16, ARRAYINT32, ARRAYINT64, ARRAYINT8, ARRAYMUL, BOOL, COMPLEX, COMPLEX128, COMPLEX64, DATE, FLOAT, FLOAT32, FLOAT64, INT, INT16, INT32, INT64, INT8, OBJECT, RGB, RGB8, STRING`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ShortDataset` | `asNonCompoundDataset(boolean shareData)` Get a non-compound dataset version
    `CompoundShortDataset` | `clone()` Clone dataset
    `boolean` | `containsInfs()`
    `boolean` | `containsInvalidNumbers()`
    `boolean` | `containsNans()`
    `void` | `copyElements(Dataset destination, int element)` Copy chosen elements from each item to another dataset
    `void` | `copyItemsFromAxes(int[] pos, boolean[] axes, Dataset dest)` Copy content from axes in given position to array
    `protected short[]` | `createArray(int size)`
    `static CompoundShortDataset` | `createCompoundDatasetWithLastDimension(Dataset a, boolean shareData)` Create a compound dataset using last dimension of given dataset
    `static CompoundShortDataset` | `createFromObject(int itemSize, Object obj)` Create a 1D dataset from an object which could be a Java list, array (of arrays...) or Number.
    `boolean` | `equals(Object obj)`
    `CompoundShortDataset` | `fill(Object obj)` Fill dataset with given object
    `void` | `fillDataset(Dataset result, IndexIterator iter)` Populate another dataset with part of current dataset
    `short[]` | `getAbs(int index)` Get values at absolute index in the internal array.
    `void` | `getAbs(int index, short[] values)` Get values at absolute index in the internal array.
    `protected int` | `getBufferLength()`
    `byte[]` | `getByteArray()`
    `byte[]` | `getByteArray(int... pos)`
    `byte[]` | `getByteArray(int i)`
    `byte[]` | `getByteArray(int i, int j)`
    `short[]` | `getData()` This is a typed version of `AbstractDataset.getBuffer()`
    `double[]` | `getDoubleArray()`
    `double[]` | `getDoubleArray(int... pos)`
    `double[]` | `getDoubleArray(int i)`
    `double[]` | `getDoubleArray(int i, int j)`
    `void` | `getDoubleArrayAbs(int index, double[] darray)` Get an item as a double array
    `boolean` | `getElementBooleanAbs(int index)` Get an element from given absolute index as a boolean.
    `double` | `getElementDoubleAbs(int index)` Get an element from given absolute index as a double.
    `long` | `getElementLongAbs(int index)` Get an element from given absolute index as a long.
    `ShortDataset` | `getElements(int element)` Get chosen elements from each item as a dataset
    `ShortDataset` | `getElementsView(int element)` Get chosen elements from each item as a view on dataset
    `protected double` | `getFirstValue()`
    `protected double` | `getFirstValue(int... pos)`
    `protected double` | `getFirstValue(int i)`
    `protected double` | `getFirstValue(int i, int j)`
    `float[]` | `getFloatArray()`
    `float[]` | `getFloatArray(int... pos)`
    `float[]` | `getFloatArray(int i)`
    `float[]` | `getFloatArray(int i, int j)`
    `int[]` | `getIntArray()`
    `int[]` | `getIntArray(int... pos)`
    `int[]` | `getIntArray(int i)`
    `int[]` | `getIntArray(int i, int j)`
    `long[]` | `getLongArray()`
    `long[]` | `getLongArray(int... pos)`
    `long[]` | `getLongArray(int i)`
    `long[]` | `getLongArray(int i, int j)`
    `Object` | `getObject()` Get first item as an object.
    `Object` | `getObject(int... pos)`
    `Object` | `getObject(int i)` Get an item from given position as an object.
    `Object` | `getObject(int i, int j)` Get an item from given position as an object.
    `Object` | `getObjectAbs(int index)` Get an item from given absolute index as an object.
    `short[]` | `getShortArray()`
    `short[]` | `getShortArray(int... pos)`
    `short[]` | `getShortArray(int i)`
    `short[]` | `getShortArray(int i, int j)`
    `CompoundShortDataset` | `getSlice(SliceIterator siter)` Get a slice of the dataset.
    `String` | `getString()` Get first item as a string.
    `String` | `getString(int... pos)`
    `String` | `getString(int i)` Get an item from given position as a string.
    `String` | `getString(int i, int j)` Get an item from given position as a string.
    `String` | `getStringAbs(int index)` Get an item from given absolute index as a string.
    `CompoundShortDataset` | `getView(boolean deepCopyMetadata)`
    `int` | `hashCode()`
    `CompoundShortDataset` | `iadd(Object b)` In-place addition
    `CompoundShortDataset` | `idivide(Object b)` In-place division
    `CompoundShortDataset` | `ifloor()` In-place floor
    `CompoundShortDataset` | `imultiply(Object b)` In-place multiplication
    `CompoundShortDataset` | `ipower(Object b)` In-place raise to power of argument
    `CompoundShortDataset` | `iremainder(Object b)` In-place remainder of division
    `CompoundShortDataset` | `isubtract(Object b)` In-place subtraction
    `double` | `residual(Object b, Dataset w, boolean ignoreNaNs)` Calculate residual of dataset with object and weight.
    `void` | `resize(int... newShape)` Change shape and size of dataset in-place
    `void` | `set(Object obj)` Set the value given by object at the first position.
    `void` | `set(Object obj, int... pos)` Set the value given by object at given position
    `void` | `set(Object obj, int i)` Set the value given by object at given position.
    `void` | `set(Object obj, int i, int j)` Set the value given by object at given position.
    `void` | `setAbs(int index, short val)` Set element value at absolute index in the internal array.
    `void` | `setAbs(int index, short[] val)` Set values at absolute index in the internal array.
    `CompoundShortDataset` | `setBy1DIndex(Object o, Dataset index)` This is modelled after the NumPy set item with an index dataset
    `CompoundShortDataset` | `setByBoolean(Object o, Dataset selection)` This is modelled after the NumPy set item with a condition specified by a boolean dataset
    `CompoundShortDataset` | `setByIndexes(Object o, Object... indexes)` This is modelled after the NumPy set item with an array of indexing objects
    `protected void` | `setData()` Set aliased data as base data
    `void` | `setElements(Dataset source, int element)` Set values of chosen elements from each item according to source dataset
    `void` | `setItem(short[] d)` Set values at first position.
    `void` | `setItem(short[] d, int... pos)` Set values at given position
    `void` | `setItem(short[] d, int i)` Set values at given position.
    `void` | `setItem(short[] d, int i, int j)` Set values at given position.
    `protected void` | `setItemDirect(int dindex, int sindex, Object src)` Set item from compatible dataset in a direct and speedy way.
    `void` | `setItemsOnAxes(int[] pos, boolean[] axes, Object src)` Set content on axes in given position to values in array
    `void` | `setObjectAbs(int index, Object obj)` Set an item at absolute index from an object.
    `CompoundShortDataset` | `setSlice(Object o, IndexIterator siter)`

    - ### Methods inherited from class org.eclipse.january.dataset.AbstractCompoundDataset

      `argMax, argMin, cast, cast, flatten, get1DIndex, get1DIndex, get1DIndexFromShape, getBoolean, getBoolean, getBoolean, getBoolean, getBroadcastView, getBy1DIndex, getByBoolean, getByIndexes, getByte, getByte, getByte, getByte, getCompoundStats, getDouble, getDouble, getDouble, getDouble, getDoubleArray, getDoubleArray, getDoubleArray, getDoubleArray, getElementsPerItem, getError, getError, getError, getErrorArray, getErrorArray, getErrorArray, getErrors, getFloat, getFloat, getFloat, getFloat, getInt, getInt, getInt, getInt, getIterator, getIterator, getLong, getLong, getLong, getLong, getShort, getShort, getShort, getShort, getSlice, getSlice, getSlice, getSlice, getSlice, getSlice, getSliceView, getSliceView, getSliceView, getTransposedView, getUniqueItems, ifloorDivide, internalGetSliceIterator, max, max, maxItem, maxPos, mean, mean, min, min, minItem, minPos, peakToPeak, product, reshape, rootMeanSquare, rootMeanSquare, setSlice, setSlice, sort, squeeze, squeeze, squeezeEnds, stdDeviation, stdDeviation, sum, sum, swapAxes, synchronizedCopy, transpose, variance, variance, variance`

    - ### Methods inherited from class org.eclipse.january.dataset.AbstractDataset

      `all, all, any, any, argMax, argMin, calcSteps, cast, cast, checkAxis, checkAxis, checkCompatibility, copy, copy, copyToView, count, count, count, createStrides, createStrides, createStrides, createStrides, fillData, get1DIndex, get1DIndexFromShape, getBooleanIterator, getBooleanIterator, getBuffer, getDType, getElementClass, getError, getErrorBuffer, getFirst1DIndex, getIndices, getInternalSquaredError, getItemBytes, getIterator, getMaxLineLength, getNbytes, getNDPosition, getOffset, getPositionIterator, getRank, getRealPart, getRealView, getShape, getShapeRef, getSize, getSliceIterator, getSliceIterator, getSliceIteratorFromAxes, getStats, getStrides, getStringStats, hasFloatingPointElements, isCompatibleWith, isComplex, max, mean, min, overrideInternal, peakToPeak, peakToPeak, product, product, residual, residual, rootMeanSquare, setErrorBuffer, setMaxLineLength, setShape, setSlice, setStringFormat, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, toString, toString, variance, variance, variance`

    - ### Methods inherited from class org.eclipse.january.dataset.LazyDatasetBase

      `addMetadata, checkPermutatedAxes, checkSliceND, clearMetadata, copyMetadata, copyMetadata, createFromSerializable, dirtyMetadata, findMetadataTypeSubInterfaces, getErrorMetadata, getFirstMetadata, getMetadata, getMetadata, getMetadataMap, getName, hasErrors, reshapeMetadata, restoreMetadata, setDirty, setErrors, setMetadata, setName, sliceMetadata, transposeMetadata`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.january.dataset.Dataset

      `all, all, any, any, argMax, argMin, cast, cast, checkAxis, checkCompatibility, copy, copy, count, count, count, get1DIndex, getBooleanIterator, getBooleanIterator, getBuffer, getDType, getError, getErrorBuffer, getIndices, getIterator, getNbytes, getNDPosition, getOffset, getPositionIterator, getRealPart, getRealView, getShapeRef, getSliceIterator, getSliceIterator, getSliceIteratorFromAxes, getStrides, hasFloatingPointElements, isCompatibleWith, isComplex, max, mean, min, overrideInternal, peakToPeak, peakToPeak, product, product, residual, residual, rootMeanSquare, setDirty, setErrorBuffer, setSlice, stdDeviation, stdDeviation, stdDeviation, stdDeviation, sum, toString, variance, variance, variance`

    - ### Methods inherited from interface org.eclipse.january.dataset.IDataset

      `getItemBytes, getMetadata, setStringFormat`

    - ### Methods inherited from interface org.eclipse.january.dataset.ILazyDataset

      `addMetadata, clearMetadata, getElementClass, getRank, getShape, getSize, hasErrors, setErrors, setMetadata, setShape`

    - ### Methods inherited from interface org.eclipse.january.dataset.IMetadataProvider

      `getFirstMetadata, getMetadata`

    - ### Methods inherited from interface org.eclipse.january.INameable

      `getName, setName`

- - ### Field Detail

    - #### data

          protected short[] data

  - ### Method Detail

    - #### setData

          protected void setData()

      Description copied from class: `AbstractDataset`
      Set aliased data as base data
      Specified by:
        `setData` in class `AbstractDataset`

    - #### createArray

          protected short[] createArray(int size)

    - #### equals

          public boolean equals(Object obj)

      Overrides:
        `equals` in class `AbstractCompoundDataset`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractCompoundDataset`

    - #### clone

          public CompoundShortDataset clone()

      Description copied from interface: `ILazyDataset`
      Clone dataset
      Specified by:
        `clone` in interface `CompoundDataset`
      Specified by:
        `clone` in interface `Dataset`
      Specified by:
        `clone` in interface `IDataset`
      Specified by:
        `clone` in interface `ILazyDataset`
      Specified by:
        `clone` in class `AbstractCompoundDataset`
      Returns:
        a (shallow) copy of dataset

    - #### createFromObject

          public static CompoundShortDataset createFromObject(int itemSize,
                                                              Object obj)

      Create a 1D dataset from an object which could be a Java list, array (of arrays...) or Number. Ragged sequences or arrays are padded with zeros.
      Parameters:
        `itemSize` - item size
        `obj` - object
      Returns:
        dataset with contents given by input

    - #### createCompoundDatasetWithLastDimension

          public static CompoundShortDataset createCompoundDatasetWithLastDimension(Dataset a,
                                                                                    boolean shareData)

      Create a compound dataset using last dimension of given dataset
      Parameters:
        `a` - dataset
        `shareData` - if true, then share data when possible otherwise copy it
      Returns:
        compound dataset

    - #### asNonCompoundDataset

          public ShortDataset asNonCompoundDataset(boolean shareData)

      Description copied from interface: `CompoundDataset`
      Get a non-compound dataset version
      Parameters:
        `shareData` - if true, then share data when possible otherwise copy it
      Returns:
        non-compound dataset

    - #### fill

          public CompoundShortDataset fill(Object obj)

      Description copied from interface: `Dataset`
      Fill dataset with given object
      Parameters:
        `obj` - fill value
      Returns:
        filled dataset with each item being equal to the given object

    - #### getData

          public short[] getData()

      This is a typed version of `AbstractDataset.getBuffer()`
      Returns:
        data buffer as linear array

    - #### getBufferLength

          protected int getBufferLength()

      Specified by:
        `getBufferLength` in class `AbstractDataset`
      Returns:
        entire buffer length

    - #### getView

          public CompoundShortDataset getView(boolean deepCopyMetadata)

      Specified by:
        `getView` in interface `CompoundDataset`
      Specified by:
        `getView` in interface `Dataset`
      Specified by:
        `getView` in class `AbstractCompoundDataset`
      Parameters:
        `deepCopyMetadata` - if true then deep-copy metadata
      Returns:
        whole view of dataset (i.e. data buffer is shared)

    - #### getAbs

          public short[] getAbs(int index)

      Get values at absolute index in the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
      Returns:
        values

    - #### getAbs

          public void getAbs(int index,
                             short[] values)

      Get values at absolute index in the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
        `values` - output destination

    - #### getElementBooleanAbs

          public boolean getElementBooleanAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a boolean. See warning in interface doc
      Parameters:
        `index` - in array
      Returns:
        element as boolean

    - #### getElementDoubleAbs

          public double getElementDoubleAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a double. See warning in interface doc
      Parameters:
        `index` - in array
      Returns:
        element as double

    - #### getElementLongAbs

          public long getElementLongAbs(int index)

      Description copied from interface: `Dataset`
      Get an element from given absolute index as a long. See warning in interface doc
      Parameters:
        `index` - in array
      Returns:
        element as long

    - #### setItemDirect

          protected void setItemDirect(int dindex,
                                       int sindex,
                                       Object src)

      Description copied from class: `AbstractDataset`
      Set item from compatible dataset in a direct and speedy way. Remember to setDirty afterwards.
      Specified by:
        `setItemDirect` in class `AbstractDataset`
      Parameters:
        `dindex` - destination index
        `sindex` - source index
        `src` - is the source data buffer

    - #### setAbs

          public void setAbs(int index,
                             short[] val)

      Set values at absolute index in the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
        `val` - new values

    - #### setAbs

          public void setAbs(int index,
                             short val)

      Set element value at absolute index in the internal array. This is an internal method with no checks so can be dangerous. Use with care or ideally with an iterator.
      Parameters:
        `index` - absolute index
        `val` - new value

    - #### getObject

          public Object getObject()

      Description copied from interface: `Dataset`
      Get first item as an object. The dataset must not be null
      Returns:
        item

    - #### getObject

          public Object getObject(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as an object. The dataset must be 1D
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getObject

          public Object getObject(int i,
                                  int j)

      Description copied from interface: `Dataset`
      Get an item from given position as an object. The dataset must be 2D
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getObject

          public Object getObject(int... pos)

      Parameters:
        `pos` - position
      Returns:
        Item in given position as an object

    - #### getByteArray

          public byte[] getByteArray()

      Returns:
        item in first position

    - #### getByteArray

          public byte[] getByteArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getByteArray

          public byte[] getByteArray(int i,
                                     int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getByteArray

          public byte[] getByteArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getShortArray

          public short[] getShortArray()

      Returns:
        item in first position

    - #### getShortArray

          public short[] getShortArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getShortArray

          public short[] getShortArray(int i,
                                       int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getShortArray

          public short[] getShortArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getIntArray

          public int[] getIntArray()

      Returns:
        item in first position

    - #### getIntArray

          public int[] getIntArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getIntArray

          public int[] getIntArray(int i,
                                   int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getIntArray

          public int[] getIntArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getLongArray

          public long[] getLongArray()

      Returns:
        item in first position

    - #### getLongArray

          public long[] getLongArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getLongArray

          public long[] getLongArray(int i,
                                     int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getLongArray

          public long[] getLongArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getFloatArray

          public float[] getFloatArray()

      Returns:
        item in first position

    - #### getFloatArray

          public float[] getFloatArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getFloatArray

          public float[] getFloatArray(int i,
                                       int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getFloatArray

          public float[] getFloatArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getDoubleArray

          public double[] getDoubleArray()

      Returns:
        item in first position

    - #### getDoubleArray

          public double[] getDoubleArray(int i)

      Parameters:
        `i` - position in first dimension
      Returns:
        item in given position

    - #### getDoubleArray

          public double[] getDoubleArray(int i,
                                         int j)

      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item in given position

    - #### getDoubleArray

          public double[] getDoubleArray(int... pos)

      Parameters:
        `pos` - position
      Returns:
        item in given position

    - #### getDoubleArrayAbs

          public void getDoubleArrayAbs(int index,
                                        double[] darray)

      Description copied from interface: `CompoundDataset`
      Get an item as a double array
      Parameters:
        `index` - in array
        `darray` - double array must be allocated and have sufficient length

    - #### getString

          public String getString()

      Description copied from interface: `Dataset`
      Get first item as a string. The dataset must not be null
      Returns:
        item

    - #### getString

          public String getString(int i)

      Description copied from interface: `Dataset`
      Get an item from given position as a string. The dataset must be 1D
      Parameters:
        `i` - position in first dimension
      Returns:
        item

    - #### getString

          public String getString(int i,
                                  int j)

      Description copied from interface: `Dataset`
      Get an item from given position as a string. The dataset must be 2D
      Parameters:
        `i` - position in first dimension
        `j` - position in second dimension
      Returns:
        item

    - #### getString

          public String getString(int... pos)

      Parameters:
        `pos` - position
      Returns:
        Item in given position as a string

    - #### getFirstValue

          protected double getFirstValue()

      Specified by:
        `getFirstValue` in class `AbstractCompoundDataset`
      Returns:
        first value

    - #### getFirstValue

          protected double getFirstValue(int i)

      Specified by:
        `getFirstValue` in class `AbstractCompoundDataset`

    - #### getFirstValue

          protected double getFirstValue(int i,
                                         int j)

      Specified by:
        `getFirstValue` in class `AbstractCompoundDataset`

    - #### getFirstValue

          protected double getFirstValue(int... pos)

      Specified by:
        `getFirstValue` in class `AbstractCompoundDataset`

    - #### getObjectAbs

          public Object getObjectAbs(int index)

      Description copied from interface: `Dataset`
      Get an item from given absolute index as an object. See warning in interface doc
      Parameters:
        `index` - in array
      Returns:
        item

    - #### getStringAbs

          public String getStringAbs(int index)

      Description copied from interface: `Dataset`
      Get an item from given absolute index as a string. See warning in interface doc
      Parameters:
        `index` - in array
      Returns:
        item

    - #### setObjectAbs

          public void setObjectAbs(int index,
                                   Object obj)

      Description copied from interface: `Dataset`
      Set an item at absolute index from an object. See warning in interface doc
      Parameters:
        `index` - in array
        `obj` - value to set

    - #### set

          public void set(Object obj)

      Description copied from interface: `Dataset`
      Set the value given by object at the first position. The dataset must not be null
      Parameters:
        `obj` - value to set

    - #### set

          public void set(Object obj,
                          int i)

      Description copied from interface: `Dataset`
      Set the value given by object at given position. The dataset must be 1D
      Parameters:
        `obj` - value to set
        `i` - position in first dimension

    - #### set

          public void set(Object obj,
                          int i,
                          int j)

      Description copied from interface: `Dataset`
      Set the value given by object at given position. The dataset must be 2D
      Parameters:
        `obj` - value to set
        `i` - position in first dimension
        `j` - position in second dimension

    - #### set

          public void set(Object obj,
                          int... pos)

      Description copied from interface: `IDataset`
      Set the value given by object at given position
      Parameters:
        `obj` - value to set
        `pos` - position

    - #### setItem

          public void setItem(short[] d)

      Set values at first position. The dataset must not be null
      Parameters:
        `d` - input source
      Since:
        2.0

    - #### setItem

          public void setItem(short[] d,
                              int i)

      Set values at given position. The dataset must be 1D
      Parameters:
        `d` - input source
        `i` - position in first dimension

    - #### setItem

          public void setItem(short[] d,
                              int i,
                              int j)

      Set values at given position. The dataset must be 1D
      Parameters:
        `d` - input source
        `i` - position in first dimension
        `j` - position in second dimension

    - #### setItem

          public void setItem(short[] d,
                              int... pos)

      Set values at given position
      Parameters:
        `d` - input source
        `pos` - position

    - #### resize

          public void resize(int... newShape)

      Description copied from interface: `IDataset`
      Change shape and size of dataset in-place
      Parameters:
        `newShape` - to use

    - #### getSlice

          public CompoundShortDataset getSlice(SliceIterator siter)

      Description copied from class: `AbstractDataset`
      Get a slice of the dataset. The returned dataset is a copied selection of items
      Specified by:
        `getSlice` in class `AbstractCompoundDataset`
      Parameters:
        `siter` - Slice iterator
      Returns:
        The dataset of the sliced data

    - #### getElementsView

          public ShortDataset getElementsView(int element)

      Description copied from interface: `CompoundDataset`
      Get chosen elements from each item as a view on dataset
      Parameters:
        `element` - to choose
      Returns:
        view dataset of chosen elements

    - #### getElements

          public ShortDataset getElements(int element)

      Description copied from interface: `CompoundDataset`
      Get chosen elements from each item as a dataset
      Parameters:
        `element` - to choose
      Returns:
        dataset of chosen elements

    - #### copyElements

          public void copyElements(Dataset destination,
                                   int element)

      Description copied from interface: `CompoundDataset`
      Copy chosen elements from each item to another dataset
      Parameters:
        `destination` - dataset
        `element` - to choose

    - #### setElements

          public void setElements(Dataset source,
                                  int element)

      Description copied from interface: `CompoundDataset`
      Set values of chosen elements from each item according to source dataset
      Parameters:
        `source` - dataset
        `element` - to choose

    - #### fillDataset

          public void fillDataset(Dataset result,
                                  IndexIterator iter)

      Description copied from interface: `Dataset`
      Populate another dataset with part of current dataset
      Parameters:
        `result` - destination for items from iteration
        `iter` - over current dataset

    - #### setByBoolean

          public CompoundShortDataset setByBoolean(Object o,
                                                   Dataset selection)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with a condition specified by a boolean dataset
      Parameters:
        `o` - specifies the object used to set the selected items
        `selection` - a boolean dataset of same shape to use for selecting items
      Returns:
        The dataset with modified content

    - #### setBy1DIndex

          public CompoundShortDataset setBy1DIndex(Object o,
                                                   Dataset index)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an index dataset
      Parameters:
        `o` - specifies the object used to set the selected items
        `index` - an integer dataset
      Returns:
        The dataset with modified content

    - #### setByIndexes

          public CompoundShortDataset setByIndexes(Object o,
                                                   Object... indexes)

      Description copied from interface: `Dataset`
      This is modelled after the NumPy set item with an array of indexing objects
      Parameters:
        `o` - specifies the object used to set the selected items
        `indexes` - an array of integer dataset, boolean dataset, slices or null entries (same as full slices)
      Returns:
        The dataset with modified content

    - #### setSlice

          public CompoundShortDataset setSlice(Object o,
                                               IndexIterator siter)

      Parameters:
        `o` - specifies the object used to set the specified slice
        `siter` - specifies the slice iterator
      Returns:
        this

    - #### copyItemsFromAxes

          public void copyItemsFromAxes(int[] pos,
                                        boolean[] axes,
                                        Dataset dest)

      Description copied from interface: `Dataset`
      Copy content from axes in given position to array
      Parameters:
        `pos` - starting position (can be null for origin)
        `axes` - if true, copy
        `dest` - destination

    - #### setItemsOnAxes

          public void setItemsOnAxes(int[] pos,
                                     boolean[] axes,
                                     Object src)

      Description copied from interface: `Dataset`
      Set content on axes in given position to values in array
      Parameters:
        `pos` - starting position (can be null for origin)
        `axes` - if true, copy
        `src` - source

    - #### containsNans

          public boolean containsNans()

      Returns:
        true if dataset contains any NaNs

    - #### containsInfs

          public boolean containsInfs()

      Returns:
        true if dataset contains any infinities

    - #### containsInvalidNumbers

          public boolean containsInvalidNumbers()

      Returns:
        true if dataset contains any NaNs or infinities

    - #### iadd

          public CompoundShortDataset iadd(Object b)

      Description copied from interface: `Dataset`
      In-place addition
      Parameters:
        `b` - object to use
      Returns:
        sum dataset

    - #### isubtract

          public CompoundShortDataset isubtract(Object b)

      Description copied from interface: `Dataset`
      In-place subtraction
      Parameters:
        `b` - object to use
      Returns:
        difference dataset

    - #### imultiply

          public CompoundShortDataset imultiply(Object b)

      Description copied from interface: `Dataset`
      In-place multiplication
      Parameters:
        `b` - object to use
      Returns:
        product dataset

    - #### idivide

          public CompoundShortDataset idivide(Object b)

      Description copied from interface: `Dataset`
      In-place division
      Parameters:
        `b` - object to use
      Returns:
        dividend dataset

    - #### ifloor

          public CompoundShortDataset ifloor()

      Description copied from interface: `Dataset`
      In-place floor
      Returns:
        floored dataset

    - #### iremainder

          public CompoundShortDataset iremainder(Object b)

      Description copied from interface: `Dataset`
      In-place remainder of division
      Parameters:
        `b` - object to use
      Returns:
        remaindered dataset

    - #### ipower

          public CompoundShortDataset ipower(Object b)

      Description copied from interface: `Dataset`
      In-place raise to power of argument
      Parameters:
        `b` - object to use
      Returns:
        raised dataset

    - #### residual

          public double residual(Object b,
                                 Dataset w,
                                 boolean ignoreNaNs)

      Description copied from interface: `Dataset`
      Calculate residual of dataset with object and weight. The weight is used to multiply the squared differences
      Parameters:
        `b` - object to use
        `w` - to use
        `ignoreNaNs` - if true, skip NaNs
      Returns:
        sum of the squares of the differences

Copyright © 2014–2022 Eclipse Foundation. All rights reserved.